'P2 Test Toolbox
'Version 1.8 - Ozpropdev 22nd March 2014
'FPGA Byuld (20th March 2014)
'*******************************************************************************************

	rx = 91
	tx = 90
	baudrate = 19200

dat			orgh	$e00/4			'F11 ro run in Pnut
			org

			jmp	@toolbox		'Hit <Backspace> to start

'*******************************************************************************************
' *** TEST AREA ***

test_instruction	blsize	d_reg
			ret

s_reg			long	0
d_reg			long	0
u_reg			long	0


test_data		long	data_end-test_data	'list size
			long	%1011
			long	%11
			long	%110111000
			long	0
data_end		long	$ffffffff
	

'*******************************************************************************************

read_cogram		setd	myinda,val2
			nop
			nop
			nop
myinda			pushb	0-0
			reta

start_trace16		retd
			clrb	myflags,#trace32
			setrace	#%1111   '16 bit trace on pins 112 to 127
			setxfr	#%1_110_111,#0	'start trace 16 bit
	
start_trace32		retd
			setb	myflags,#trace32
			setrace	#%0111   '32 bit trace on pins 96 to 127
			setxfr	#%1_111_111,#0	'start trace 32 bit
	

'*******************************************************************************************

myflags			long	0
elapsed			long	0
enables			long	%1111
option_reg		long	0
cmd			long	0
val			long	0
val2			long	0
zc_flags		long	0
bin_style		long	0
hex_style		long	0
hex_digits		long	0
bin_digits		long	0

mode			long	0
pass			long	0
log			long	0
log_index		long	0
task			long	0
record			long	0
macro_mode		long	0
macro_index		long	0
_macro_addr		long	@macro
ptra2			long	0
ptrb2			long	0
mystack_backup		long	0
qreg			long	0
dump_mode		long	0

_d_buffer		long	@d_buffer
_bin_formats		long	@bin_formats 
_hex_formats		long	@hex_formats 

config			long	%10 << 16 | rx << 9 | %10 << 7 | tx

_mystack		long	@mystack
_mystack2		long	@mystack2

_test_data		long	@test_data
test_index		long	0
test_count		long	0

_msg_table		long	@msg_table
_bad_msg_num		long	@bad_msg

key			long	0
tmp			long	0
ax			long	0
bx			long	0
cx			long	0
dx			long	0
ex			long	0
fx			long	0
res1			long	0
res0			long	0
repeats			long	0

old_s_reg		long	0
old_d_reg		long	0
status			long	0
new_s_reg		long	0
new_d_reg		long	0


'*******************************************************************************************
			orgh

_tested_		byte	"BLSIZE D ",0

_header_		byte	"Test of BLSIZE instruction",0

'' Pre load commands here for  convenience and use "M" to run sequence
''Terminate with a zero byte

macro			byte	"l+"	'start logger
			byte	"q7+"	'header in log output
			byte	"q5+"	'Hide after display
			byte	"*"	'execute using data from list
			byte	"v2="	'shiwlogger result
			byte	0

'*******************************************************************************************
con

	#0,c_flag,z_flag
	#1,dreg,sreg,zflag,cflag,imed,exec,logger,cogram
	hubram,dumpmode,view,effect,user_reg,options,auxdump,trace

	logger_size = 512

	wz_effect = 24
	wc_effect = 23

'option bits
	#0
	hide_inst
	hide_sreg
	show_ureg
	show_etime
	hide_after
	show_header
	show_header_log

'flags
	#0
	trace32

'*******************************************************************************************
dat
			orgh

toolbox			locptra	@mystack
			locptrb	@mystack2

			loclong	bx,@@msg_table


			reps	#256,#1		'fill aux with 0's
			setptry	#0
			wraux	#0,ptry++

			setsera	config,##80_000_000 / baudrate	'setip comms
			clrp	#90

			setxch	##$01010101
			mov	dird,##$ffffffff
			mov	outd,#0

:loop			serina	key			'press "bacspace" to start
			cmp	key,#8 wz,wc
		if_ne	jmp	@:loop


			pushb	#msg_title
			calla	@show_msg
			calla	@after

prompt			serouta	#">"
			mov	val,#0
			mov	val2,#9
			mov	cmd,#0
			mov	mode,#0
			
wait4key		jz	macro_mode,@w4k
			rdbyte	key,macro_index wz
		if_z	mov	macro_mode,#0
			add	macro_index,#1
			jmp	@w4k_2

w4k			serina	key
w4k_2			chklet	key			'make uppercase

			cmp	key,#27	wz,wc		'esc = cancel
		if_e	jmp	@prompt

			serouta	key

			cmp	key,#"_" wz,wc		'underscore
		if_e	jmp	@wait4key

			cmp	key,#"J" wz,wc		'set dump mode
		if_e	mov	cmd,#dumpmode
		

			cmp	key,#"H" wz,wc		'show hub ram
		if_e	mov	mode,#1  		'switch to hex mode
		if_e	mov	cmd,#hubram
		if_e	jmp	@clear

			cmp	key,#"M" wz,wc		'run macro
		if_e	mov	macro_mode,#1
		if_e	mov	macro_index,_macro_addr

			cmp	key,#"," wz,wc		'comma
		if_e	mov	val2,val
		if_e	mov	val,#0

			cmp	key,#"G" wz,wc		'show cog ram
		if_e	mov	mode,#1  		'switch to hex mode
		if_e	mov	cmd,#cogram
		if_e	jmp	@clear

			cmp	key,#"?" wz,wc		'help
		if_e	calla	@show_help

			cmp	key,#"R" wz,wc		'refresh
		if_e	calla	@after
		if_e	jmp	@prompt

			cmp	key,#"T" wz,wc		'dest reg
		if_e	mov	cmd,#dreg
		if_e	jmp	@clear

			cmp	key,#"S" wz,wc		'source reg
		if_e	mov	cmd,#sreg
		if_e	jmp	@clear

			cmp	key,#"Z" wz,wc		'zero flag
		if_e	mov	cmd,#zflag
		if_e	jmp	@clear

			cmp	key,#"Y" wz,wc		'carry 		flag
		if_e	mov	cmd,#cflag
		if_e	jmp	@clear

			cmp	key,#"I" wz,wc		'immediate
		if_e	mov	cmd,#imed
		if_e	jmp	@clear

			cmp	key,#"+" wz,wc		'increment
		if_e	jmp	@inc

			cmp	key,#"-" wz,wc		'decrement
		if_e	jmp	@dec

			cmp	key,#"=" wz,wc		'load
		if_e	jmp	@load
			cmp	key,#13 wz,wc		'load
		if_e	jmp	@load

			cmp	key,#"#" wz,wc		'dec mode
		if_e	mov	mode,#0
		if_e	jmp	@clear

			cmp	key,#"$" wz,wc		'hex mode
		if_e	mov	mode,#1
		if_e	jmp	@clear

			cmp	key,#"%" wz,wc		'binary mode
		if_e	mov	mode,#2
		if_e	jmp	@clear

			cmp	key,#"^" wz,wc		'bit number mode
		if_e	mov	mode,#3
		if_e	jmp	@clear

			cmp	key,#"X" wz,wc		'execute 1 or multiple times
		if_e	mov	cmd,#exec
		if_e	jmp	@clear

			cmp	key,#"O" wz,wc		'execute once
		if_e	calla	@before
		if_e	calla	@execute
		if_e	jmp	@prompt

			cmp	key,#"N" wz,wc		'header
		if_e	calla	@before
		if_e	jmp	@prompt

			cmp	key,#"L" wz,wc		'logger
		if_e	mov	cmd,#logger
		if_e	jmp	@clear

			cmp	key,#"V" wz,wc		'view log
		if_e	mov	cmd,#view
		if_e	jmp	@clear			

			cmp	key,#"[" wz,wc		'left align
		if_e	jmp	@left_align

			cmp	key,#"]" wz,wc		'right align
		if_e	jmp	@right_align

			cmp	key,#">" wz,wc		'shift right
		if_e	jmp	@right_shift

			cmp	key,#"<" wz,wc		'shift_left
		if_e	jmp	@left_shift


			cmp	key,#"K" wz,wc		'show trace
		if_e	mov	cmd,#trace
		if_e	mov	mode,#3   'but entry mode
		if_e	jmp	@clear

			cmp	key,#"P" wz,wc		'wipe trace
		if_e	jmp	@wipe_trace

			cmp	key,#"W" wz,wc		'set WZ and WC effects
		if_e	mov	cmd,#effect
		if_e	jmp	@clear

			cmp	key,#"U" wz,wc		'user register
		if_e	mov	cmd,#user_reg
		if_e	jmp	@clear

			cmp	key,#"Q" wz,wc		'set options
		if_e	mov	cmd,#options
		if_e	jmp	@clear

			cmp	key,#"@" wz,wc		'dump aux ram
		if_e	mov	mode,#1  		'switch to hex mode
		if_e	mov	cmd,#auxdump
		if_e	jmp	@clear

			cmp	key,#"*" wz,wc
		if_e	jmp	@process_data

			jmplist	mode,@modelist
modelist		jmp	@dec_entry
			jmp	@hex_entry
			jmp	@bin_entry
			jmp	@bit_entry


dec_entry		chkdec	key wc
		if_nc	jmp	@wait4key
			mul	val,#10
			add	val,key
			jmp	@wait4key

hex_entry		chkhex	key wc
		if_nc	jmp	@wait4key
			shl	val,#4
			add	val,key
			jmp	@wait4key

bin_entry		chkdec	key wc
		if_nc	jmp	@wait4key
			cmp	key,#1 wz,wc
		if_a	jmp	@wait4key
			shl	val,#1
			add	val,key
			jmp	@wait4key

bit_entry		chkdec	key wc
		if_nc	jmp	@wait4key
			decod5	key
			or	val,key
			jmp	@wait4key

'*******************************************************************************************
process_data		serouta	#13
			mov	test_index,_test_data

			rdlong	test_count,test_index
:loop			add	test_index,#4
			rdlong	d_reg,test_index
			calla	@execute
			djnz	test_count,@:loop

			jmp	@prompt
'*******************************************************************************************
set_effect		serouta	#13

			cmp	val,#3 wz,wc
		if_a	jmp	@error

			jmplist	val,@elist
elist			jmp	@no_effect
			jmp	@set_wc
			jmp	@set_wz

set_wzwc		setb	test_instruction,#wc_effect
			setb	test_instruction,#wz_effect
			calla	@after
			jmp	@prompt

set_wc			setb	test_instruction,#wc_effect
			clrb	test_instruction,#wz_effect
			calla	@after
			jmp	@prompt

set_wz			setb	test_instruction,#wz_effect
			clrb	test_instruction,#wc_effect
			calla	@after
			jmp	@prompt

no_effect		clrb	test_instruction,#wz_effect
			clrb	test_instruction,#wc_effect
			calla	@after
			jmp	@prompt
		


'*******************************************************************************************
wipe_trace		reps	#256,#1
			setptry	#0
			wraux	#0,ptry++

			pushb	#msg_done
			calla	@show_msg
			jmp	@prompt
'*******************************************************************************************
left_align		cmp	cmd,#dreg wz,wc
		if_ne	jmp	@la2
			blsize	ax,d_reg 
			subr	ax,#32
			shl	d_reg,ax

la2			cmp	cmd,#sreg wz,wc
		if_ne	jmp	@la3
			blsize	ax,s_reg
			subr	ax,#32
			shl	s_reg,ax

la3			calla	@after
			jmp	@prompt
'*******************************************************************************************
right_align		cmp	cmd,#dreg wz,wc
		if_ne	jmp	@ra2

			botone	ax,d_reg
			shr	d_reg,ax
			jmp	@ra3

ra2			cmp	cmd,#sreg wz,wc
		if_ne	jmp	@ra3

			botone	ax,s_reg
			shr	s_reg,ax

ra3			calla	@after
			jmp	@prompt
'*******************************************************************************************

left_shift		mins	val,#1

			cmp	cmd,#dreg wz,wc
		if_e	shl	d_reg,val

			cmp	cmd,#sreg wz,wc
		if_e	shl	s_reg,val

			calla	@after
			jmp	@prompt
'*******************************************************************************************
right_shift		mins	val,#1

			cmp	cmd,#dreg wz,wc
		if_e	shr	d_reg,val

			cmp	cmd,#sreg wz,wc
		if_e	shr	s_reg,val

			calla	@after
			jmp	@prompt
'*******************************************************************************************

inc			serouta	#13

			cmp	cmd,#options wz,wc
		if_ne	jmp	@inc_main

			jz	val,@prompt
			cmp	val,#32 wz,wc
		if_a	jmp	@error
			sub	val,#1
			setb	option_reg,val
			calla	@after
			jmp	@prompt

inc_main		mins	val,#1

			cmp	cmd,#dreg wz,wc
		if_e	add	d_reg,val
		if_e	calla	@after

			cmp	cmd,#sreg wz,wc
		if_e	add	s_reg,val
		if_e	calla	@after

			cmp	cmd,#zflag wz,wc
		if_e	setb	zc_flags,#z_flag
		if_e	calla	@after

			cmp	cmd,#cflag wz,wc
		if_e	setb	zc_flags,#c_flag
		if_e	calla	@after

			cmp	cmd,#imed wz,wc
		if_e	setb	test_instruction,#22
		if_e	calla	@after

			cmp	cmd,#logger wz,wc
		if_e	mov	log,#1
		if_e	calla	@after

			cmp	cmd,#dumpmode wz,wc
		if_e	incmod	dump_mode,#3
		if_e	calla	@after

			cmp	cmd,#user_reg wz,wc
		if_e	add	u_reg,val
		if_e	calla	@after


			jmp	@prompt
'*******************************************************************************************

dec			serouta	#13

			cmp	cmd,#options wz,wc
		if_ne	jmp	@dec_main

			jz	val,@@prompt
			cmp	val,#32 wz,wc
		if_a	jmp	@error
			sub	val,#1
			clrb	option_reg,val
			calla	@after
			jmp	@prompt

dec_main		mins	val,#1

			cmp	cmd,#dreg wz,wc
		if_e	sub	d_reg,val
		if_e	calla	@after

			cmp	cmd,#sreg wz,wc
		if_e	sub	s_reg,val
		if_e	calla	@after

			cmp	cmd,#zflag wz,wc
		if_e	clrb	zc_flags,#z_flag
		if_e	calla	@after

			cmp	cmd,#cflag wz,wc
		if_e	clrb	zc_flags,#c_flag
		if_e	calla	@after

			cmp	cmd,#imed wz,wc
		if_e	clrb	test_instruction,#22
		if_e	sets	test_instruction,#s_reg
		if_e	calla	@after

			cmp	cmd,#logger wz,wc
		if_e	mov	log,#0
		if_e	calla	@after

			cmp	cmd,#dumpmode wz,wc
		if_e	decmod	dump_mode,#3
		if_e	calla	@after

			cmp	cmd,#user_reg wz,wc
		if_e	sub	u_reg,val
		if_e	calla	@after


			jmp	@prompt

'*******************************************************************************************

load			cmp	key,#13 wz,wc
		if_ne	serouta	#13

			cmp	cmd,#options wz,wc
		if_e	mov	option_reg,val
		if_e	calla	@after

			cmp	cmd,#dreg wz,wc
		if_e	mov	d_reg,val
		if_e	calla	@after

			cmp	cmd,#sreg wz,wc
		if_e	mov	s_reg,val
		if_e	calla	@after

			cmp	cmd,#imed wz,wc
		if_e	setb	test_instruction,#22
		if_e	sets	test_instruction,val
		if_e	calla	@after

			cmp	cmd,#exec wz,wc
		if_e	calla	@execute

			cmp	cmd,#logger wz,wc
		if_e	mov	log_index,#0
		if_e	calla	@after

			cmp	cmd,#cogram wz,wc
		if_e	jmp	@show_cogram
			
			cmp	cmd,#hubram wz,wc
		if_e	jmp	@show_hubram
		
			cmp	cmd,#view wz,wc
		if_e	jmp	@view_log

			cmp	cmd,#effect wz,wc
		if_e	jmp	@set_effect

			cmp	cmd,#user_reg wz,wc
		if_e	mov	u_reg,val
		if_e	calla	@after

			cmp	cmd,#auxdump wz,wc
		if_e	jmp	@aux_dump

			cmp	cmd,#trace wz,wc
		if_e	jmp	@show_trace
	
			cmp	cmd,#dumpmode wz,wc
		if_ne	jmp	@prompt
			cmp	val,#3 wz,wc
		if_a	jmp	@error
			mov	dump_mode,val
			calla	@after
			jmp	@prompt

'*******************************************************************************************
update_dump_mode	cmp	dump_mode,#0 wz,wc
		if_e	pushb	#msg_byte
			cmp	dump_mode,#1 wz,wc
		if_e	pushb	#msg_word
			cmp	dump_mode,#2 wz,wc
		if_e	pushb	#msg_long
			cmp	dump_mode,#3 wz,wc
		if_e	pushb	#msg_text

			calla	@show_msg
			reta

'*******************************************************************************************

view_log		serouta	#13

			cmp	val,#2 wz,wc
		if_a	jmp	@error

			jz	log_index,@@prompt

			testb	option_reg,#show_header_log wz
		if_nz	serouta	#34
		if_nz	pushb	#msg_header
		if_nz	calla	@show_msg
		if_nz	serouta	#34
		if_nz	serouta	#13
		if_nz	serouta	#13

			jmplist	val,@vlist
vlist			jmp	@view0
			jmp	@view1
			jmp	@view2

view0			mov	repeats,log_index
			mov	dx,_d_buffer

:loop			pushb	#msg_pass
			calla	@show_msg

			rdlong	old_s_reg,dx
			add	dx,#4
			rdlong	old_d_reg,dx
			add	dx,#4
			rdlong	status,dx
			add	dx,#4
			rdlong	new_s_reg,dx
			add	dx,#4
			rdlong	new_d_reg,dx
			add	dx,#4

			mov	ax,status
			shr	ax,#16
			cmp	ax,#10 wz,wc
		if_b	serouta	#" "
			pushb	ax
			calla	@show_decimal
			serouta	#" "
			serouta	#" "

			serouta	#"S"
			serouta	#"="
			pushb	old_s_reg
			calla	@show_hex
			serouta	#" "

			serouta	#"Z"
			serouta	#"C"
			serouta	#"="

			pushb	status'ex
			mov	bin_digits,#2
			calla	@show_binary

			serouta	#" "
			serouta	#" "
			serouta	#"$"
			pushb	new_d_reg 'ex
			mov	hex_digits,#8
			mov	hex_style,#1
			calla	@show_hex
			serouta	#" "
			serouta	#" "

			serouta	#"%"
			pushb	new_d_reg  'ex
			mov	bin_digits,#32
			mov	bin_style,#2
			calla	@show_binary

			serouta	#" "
			serouta	#" "
			pushb	new_d_reg  'ex
			calla	@show_decimal
		
			
			serouta	#13
			djnz	repeats,@:loop

			jmp	@prompt

'*******************************************************************************************

view1			mov	repeats,log_index
			mov	dx,_d_buffer

:loop			pushb	#msg_pass
			calla	@show_msg

			rdlong	old_s_reg,dx
			add	dx,#4
			rdlong	old_d_reg,dx
			add	dx,#4
			rdlong	status,dx
			add	dx,#4
			rdlong	new_s_reg,dx
			add	dx,#4
			rdlong	new_d_reg,dx
			add	dx,#4

			mov	ax,status 'ex
			shr	ax,#16
			cmp	ax,#10 wz,wc
		if_b	serouta	#" "
			pushb	ax
			calla	@show_decimal
			serouta	#" "
			serouta	#" "

			pushb	#msg_tested
			calla	@show_msg

			serouta	#"S"
			serouta	#"="
			serouta	#"$"
			pushb	old_s_reg
			calla	@show_hex
			serouta	#" "

			pushb	#msg_returns
			calla	@show_msg

			serouta	#"D"
			serouta	#"="
			serouta	#"$"
	
			pushb	new_d_reg 'ex
			mov	hex_digits,#8
			mov	hex_style,#1
			calla	@show_hex
			
			serouta	#13
			djnz	repeats,@:loop

			jmp	@prompt


'*******************************************************************************************

view2			mov	repeats,log_index
			mov	dx,_d_buffer

:loop			pushb	#msg_pass
			calla	@show_msg

			rdlong	old_s_reg,dx
			add	dx,#4
			rdlong	old_d_reg,dx
			add	dx,#4
			rdlong	status,dx
			add	dx,#4
			rdlong	new_s_reg,dx
			add	dx,#4
			rdlong	new_d_reg,dx
			add	dx,#4

			mov	ax,status 'ex
			shr	ax,#16
			cmp	ax,#10 wz,wc
		if_b	serouta	#" "
			pushb	ax
			calla	@show_decimal
			serouta	#" "
			serouta	#" "

			pushb	#msg_tested
			calla	@show_msg

			serouta	#"D"
			serouta	#"="
			serouta	#"$"
			pushb	old_d_reg
			calla	@show_hex
			serouta	#" "

			pushb	#msg_returns
			calla	@show_msg

			serouta	#"D"
			serouta	#"="
			serouta	#"$"
	
			pushb	new_d_reg 'ex
			mov	hex_digits,#8
			mov	hex_style,#1
			calla	@show_hex
			
			serouta	#13
			djnz	repeats,@:loop

			jmp	@prompt


'*******************************************************************************************

update_inst		pushb	#msg_inst
			calla	@show_msg
			serouta	#"%"
			pushb	test_instruction
			mov	bin_style,#3
			mov	bin_digits,#32
			calla	@show_binary

			mov	hex_style,#0
			serouta	#" "
			serouta	#"$"
			mov	ax,test_instruction
			shr	ax,#9
			and	ax,#$1ff
			pushb	ax
			mov	hex_digits,#3
			calla	@show_hex
	
			serouta	#","
			testb	test_instruction,#22 wz
		if_nz	serouta	#"#"
			serouta	#"$"
			mov	ax,test_instruction
			and	ax,#$1ff
			pushb	ax
			mov	hex_digits,#3
			calla	@show_hex

			serouta	#" "
			mov	ax,test_instruction
			shr	ax,#9
			and	ax,#$1ff
			pushb	ax
			calla	@show_decimal

			serouta	#","
			testb	test_instruction,#22 wz
		if_nz	serouta	#"#"
			mov	ax,test_instruction
			and	ax,#$1ff
			pushb	ax
			calla	@show_decimal

			serouta	#13
			reta

'*******************************************************************************************


before			mov	pass,#0
			serouta	#13
			pushb	#msg_title
			calla	@show_msg

			testb	option_reg,#show_header wz
		if_nz	serouta	#34
		if_nz	pushb	#msg_header
		if_nz	calla	@show_msg
		if_nz	serouta	#34
		if_nz	serouta	#13

			pushb	#msg_before
			jmp	#bf2

after			pushb	#msg_after

bf2			serouta	#13
			calla	@show_msg

			testb	option_reg,#hide_inst wz
		if_nz	jmp	@compact1

			pushb	#msg_pass
			calla	@show_msg
			pushb	pass
			calla	@show_decimal


			pushb	#msg_log
			calla	@show_msg
			cmp	log,#1 wz,wc
		if_e	pushb	#msg_on	
		if_ne	pushb	#msg_off
			calla	@show_msg

			serouta	#"="
			pushb	log_index
			calla	@show_decimal

			serouta	#" "
			pushb	#msg_dump
			calla	@show_msg
			calla	@update_dump_mode

			calla	@update_inst
compact1		calla	@show_flags

			serouta	#"D"
			serouta	#"="
			pushb	d_reg
			calla	@show_reg

			testb	option_reg,#hide_sreg wz
		if_nz	jmp	@:skip2
			serouta	#"S"
			serouta	#"="
			pushb	s_reg
			calla	@show_reg

:skip2			testb	option_reg,#show_ureg wz
		if_z	jmp	@:skip
			serouta	#"U"
			serouta	#"="
			pushb	u_reg
			calla	@show_reg


:skip			serouta	#13

			reta	wz,wc

'*******************************************************************************************

show_reg		popb	qreg
			serouta	#"$"
			mov	hex_style,#1
			pushb	qreg
			mov	hex_digits,#8
			calla	@show_hex
			serouta	#" "
			serouta	#" "
			serouta	#"%"
			mov	bin_style,#2
			pushb	qreg
			mov	bin_digits,#32
			calla	@show_binary
			serouta	#" "
			serouta	#" "
			pushb	qreg
			calla	@show_decimal
			testb	qreg,#31 wz
		if_z	serouta	#13
		if_z	reta
			serouta	#" "
			serouta	#" "
			neg	ax,qreg
			pushb	ax
			serouta	#"-"
			calla	@show_decimal
			serouta	#13
			reta

'*******************************************************************************************

show_flags		pushb	#msg_flags
			calla	@show_msg
			serouta	#"Z"
			serouta	#"="
			testb	zc_flags,#z_flag wz
		if_z	serouta	#"0"
		if_nz	serouta	#"1"
			serouta	#" "
			serouta	#"C"
			serouta	#"="
			testb	zc_flags,#c_flag wz
		if_z	serouta	#"0"
		if_nz	serouta	#"1"
			serouta	#13
			reta
'*******************************************************************************************

execute			getptra	mystack_backup

			mov	repeats,val
			mins	repeats,#1
			maxs	repeats,##logger_size

:loop			jz	log,@:loop3
			mov	fx,_d_buffer	'update logger
			mov	ax,log_index
			mul	ax,#20
			add	fx,ax
			wrlong	s_reg,fx
			add	fx,#4
			wrlong	d_reg,fx
			add	fx,#4
	
:loop3			popzc	zc_flags wz,wc
			getptra	ptra2
			getptrb	ptrb2
			call	#test_instruction
			setptra	ptra2
			setptrb	ptrb2
			pushzc	zc_flags

			add	pass,#1

			jz	log,@:loop2
			mov	ax,pass		'update logger
			shl	ax,#16
			or	ax,zc_flags
			wrlong	ax,fx
			add	fx,#4
			wrlong	s_reg,fx
			add	fx,#4
			wrlong	d_reg,fx
			add	fx,#4
			incmod	log_index,##logger_size wc
		if_c	mov	log,#0
		
:loop2			testb	option_reg,#hide_after wz
		if_z	setptra	mystack_backup
		if_z	calla	@after

			djnz	repeats,@:loop

			mul	elapsed,#125	'12.5nS per cycle @ 80MHz

			testb	option_reg,#show_etime wz
		if_nz	calla	@show_elapsed
			
			reta	wz,wc

'*******************************************************************************************

clear			mov	val,#0
			mov	val2,#0
			jmp	@wait4key

'*******************************************************************************************

show_hex		mov	cx,_hex_formats
			mov	bx,hex_style
			shl	bx,#2
			add	cx,bx
			rdlong	fx,cx

			jnz	hex_digits,@:setup
			mov	hex_digits,#8

:setup			mov	bx,hex_digits
			shl	bx,#2
			subr	bx,#32

			cmp	hex_digits,#8 wz,wc
		if_ne	pushb	hex_digits
		if_ne	calla	@set_start

			popb	ax

			shl	ax,bx

:loop			rdbyte	bx,fx wz
			add	fx,#1
		if_z	reta
			cmp	bx,#"d" wz,wc
		if_e	jmp	@:loop2
			serouta	bx
			jmp	@:loop

:loop2			getnib	bx,ax,#7
			cmp	bx,#9 wz,wc
		if_be	add	bx,#"0"
		if_a	add	bx,#"A"-10
			serouta	bx
			shl	ax,#4
			jmp	@:loop

'*******************************************************************************************
set_start		popb	cx

:findz			rdbyte	ax,fx  wz
			add	fx,#1
		if_nz	jmp	@:findz		'find 0 terminator
			sub	fx,#2

:loop			rdbyte	ax,fx wz
			sub	fx,#1
		if_z	add	fx,#1
		if_z	reta
			cmp	ax,#"d" wz,wc
		if_ne	jmp	@:loop
			djnz	cx,@:loop
			add	fx,#1
			reta
'*******************************************************************************************

show_binary		mov	cx,_bin_formats
			mov	bx,bin_style
			shl	bx,#2
			add	cx,bx
			rdlong	fx,cx

			jnz	bin_digits,@:setup
			mov	bin_digits,#32

:setup			mov	bx,bin_digits
			subr	bx,#32

			cmp	bin_digits,#32 wz,wc
		if_ne	pushb	bin_digits
		if_ne	calla	@set_start

			popb	ax
			shl	ax,bx


:loop			rdbyte	bx,fx wz
			add	fx,#1
		if_z	reta
			cmp	bx,#"d" wz,wc
		if_e	jmp	@:loop2
			serouta	bx
			jmp	@:loop

:loop2			testb	ax,#31 wz
		if_z	serouta	#"0"
		if_nz	serouta	#"1"
			shl	ax,#1
			jmp	@:loop
'*******************************************************************************************

show_decimal		mov	res1,#0
			mov	res0,#0
			popb	ax

			mov	cx,#32
:loop			shl	ax,#1 wc
			binbcd	res0 wc
			binbcd	res1
			djnz	cx,@:loop

			pushb	res0
			pushb	res1
			or	res1,#0 wz
		if_z	popb	res1
		if_nz	calla	@trimmed_hex
			calla	@trimmed_hex
			reta	wz,wc

'*******************************************************************************************
			
trimmed_hex		popb	ax
			topone	bx,ax wc		'get magnitude
		if_c	serouta	#"0"
		if_c	reta
			shr	bx,#2
			add	bx,#1			'digits
			mov	cx,bx
			shl	cx,#2
			subr	cx,#32			'shift
			shl	ax,cx		
:loop			getnib	tmp,ax,#7
			cmp	tmp,#9 wz,wc
		if_be	add	tmp,#"0"
		if_a	add	tmp,#"A"-10
			serouta	tmp
			shl	ax,#4
			djnz	bx,@:loop
			reta	wz,wc

'*******************************************************************************************
show_help		pushb	#msg_help
			calla	@show_msg
			jmp	@prompt

'*******************************************************************************************
show_trace		mov	record,#0
			serouta	#13

			mov	enables,val wz
		if_z	mov	enables,#%1111

			mov	bin_digits,#16
			mov	bin_style,#4

			setptry	#$ff
			mov	repeats,#256
:look4end		rdaux	ex,ptry-- wz
		if_nz	jmp	@l4e
			djnz	repeats,@:look4end 
			jnz	repeats,@l4e
			mov	repeats,#256

l4e			setptry	#0

:loop			rdaux	val2,ptry++
			pushb	val2
			calla	@show_trace_line

			testb	myflags,#trace32 wz
		if_nz	jmp	@:loop2

			shr	val2,#16
			pushb	val2
			calla	@show_trace_line

:loop2			calla	@esc_check
		if_e	jmp	@:exit

			djnz	repeats,@:loop

:exit			setptry	val
			jmp	@prompt

'*******************************************************************************************

show_trace_line		testb	myflags,#trace32 wz
		if_nz	jmp	@show_trace32

'16 bit trace mode
			popb	cmd
			add	record,#1

			and	cmd,##$ffff

			mov	ex,cmd
			shr	ex,#14
			decod5	ex,ex
			and	ex,enables wz
		if_z	reta

			serouta	#"R"
			pushb	record
			calla	@show_decimal
			cmp	record,#10 wz,wc
		if_b	serouta	#" "
			cmp	record,#100 wz,wc
		if_b	serouta	#" "

			serouta	#" "

			pushb	#msg_task
			calla	@show_msg
			mov	task,cmd
			shr	task,#14
			and	task,#3
			mov	ax,task
			add	ax,#"0"
			serouta	ax
			serouta	#" "

			testb	cmd,#13 wz
		if_z	pushb	#msg_dash3
		if_nz	pushb	#msg_hub
			calla	@show_msg

			testb	cmd,#12 wz
		if_z	pushb	#msg_dash5
		if_nz	pushb	#msg_fetch
			calla	@show_msg

			testb	cmd,#11 wz
		if_nz	pushb	#msg_dash5
		if_z	pushb	#msg_stall
			calla	@show_msg

			testb	cmd,#10 wz
		if_nz	pushb	#msg_dash4
		if_z	pushb	#msg_skip
			calla	@show_msg

			testb	cmd,#9 wz
		if_z	pushb	#msg_dash4
		if_nz	pushb	#msg_jump
			calla	@show_msg

			serouta	#" "
			serouta	#"|"
			serouta	#" "

			jz	task,@show_task_pc
			mov	dx,task
:loop			pushb	#msg_dash4
			calla	@show_msg
			djnz	dx,@:loop

show_task_pc		serouta	#"$"
			mov	ax,cmd
			and	ax,#$1ff
			pushb	ax
			mov	hex_digits,#3
			calla	@show_hex
			serouta	#" "

			cmp	task,#3 wz,wc
		if_e	jmp	@no_dash
			subr	task,#3
			
:loop2			pushb	#msg_dash4
			calla	@show_msg
			djnz	task,@:loop2


no_dash			serouta	#13
			
			reta

'*******************************************************************************************

show_trace32		popb	cmd
			add	record,#1


			mov	ex,cmd
			shr	ex,#30
			decod5	ex,ex
			and	ex,enables wz
		if_z	reta

			mov	hex_style,#0

			serouta	#"R"
			pushb	record
			calla	@show_decimal
			cmp	record,#10 wz,wc
		if_b	serouta	#" "
			cmp	record,#100 wz,wc
		if_b	serouta	#" "

			serouta	#" "

			pushb	#msg_task
			calla	@show_msg
			mov	task,cmd
			shr	task,#30
			and	task,#3
			mov	ax,task
			add	ax,#"0"
			serouta	ax
			serouta	#" "

			testb	cmd,#29 wz
		if_z	pushb	#msg_dash3
		if_nz	pushb	#msg_hub
			calla	@show_msg

			testb	cmd,#28 wz
		if_z	pushb	#msg_dash5
		if_nz	pushb	#msg_fetch
			calla	@show_msg

			testb	cmd,#27 wz
		if_nz	pushb	#msg_dash5
		if_z	pushb	#msg_stall
			calla	@show_msg

			testb	cmd,#26 wz
		if_nz	pushb	#msg_dash4
		if_z	pushb	#msg_skip
			calla	@show_msg

			testb	cmd,#25 wz
		if_z	pushb	#msg_dash4
		if_nz	pushb	#msg_jump
			calla	@show_msg


			testb	cmd,#24 wz
		if_z	pushb	#msg_dash3
		if_nz	pushb	#msg_unknown
			calla	@show_msg


			testb	cmd,#23 wz
		if_z	pushb	#msg_dash3
		if_nz	pushb	#msg_unknown
			calla	@show_msg


			testb	cmd,#22 wz
		if_z	pushb	#msg_dash5
		if_nz	pushb	#msg_video
			calla	@show_msg

			testb	cmd,#21 wz
		if_z	pushb	#msg_dash4
		if_nz	pushb	#msg_ctra
			calla	@show_msg

			testb	cmd,#20 wz
		if_z	pushb	#msg_dash4
		if_nz	pushb	#msg_ctrb
			calla	@show_msg

			testb	cmd,#19 wz
		if_z	pushb	#msg_dash3
		if_nz	pushb	#msg_rxa
			calla	@show_msg

			testb	cmd,#18 wz
		if_z	pushb	#msg_dash3
		if_nz	pushb	#msg_txa
			calla	@show_msg

			testb	cmd,#17 wz
		if_z	pushb	#msg_dash3
		if_nz	pushb	#msg_rxb
			calla	@show_msg

			testb	cmd,#16 wz
		if_z	pushb	#msg_dash3
		if_nz	pushb	#msg_txb
			calla	@show_msg

			serouta	#" "
			serouta	#"|"
			serouta	#" "

			jz	task,@show_task_pc2
			mov	dx,task
:loop			pushb	#msg_dash5
			calla	@show_msg
			djnz	dx,@:loop

show_task_pc2		serouta	#"$"
			mov	ax,cmd
			and	ax,##$3ffff
			pushb	ax
			mov	hex_digits,#4
			calla	@show_hex
			serouta	#" "

			cmp	task,#3 wz,wc
		if_e	jmp	@no_dash2
			subr	task,#3
			
:loop2			pushb	#msg_dash5
			calla	@show_msg
			djnz	task,@:loop2


no_dash2		serouta	#13
			reta

'*******************************************************************************************
show_cogram		serouta	#13

			sub	val,val2
			add	val,#1

:loop			pushb	#msg_cogram
			calla	@show_msg

			serouta	#"$"
			pushb	val2
			mov	hex_digits,#3
			calla	@show_hex
			serouta	#":"
			serouta	#"="
			serouta	#" "

			calla	#read_cogram
			serouta	#"$"
			mov	hex_digits,#8
			calla	@show_hex
			serouta	#" "

			serouta	#"%"
			calla	#read_cogram
			mov	bin_style,#3
			mov	bin_digits,#32
			calla	@show_binary
			serouta	#" "

			calla	#read_cogram
			calla	@show_decimal

			add	val2,#1

			serouta	#13
			djnz	val,@:loop			

			jmp	@prompt

'*******************************************************************************************
esc_check		serina	ax wc
		if_c	reta
			cmp	ax,#27 wz,wc
			reta
'*******************************************************************************************
show_hubram		mov	cmd,#0

			jmplist	dump_mode,@dlist
dlist			jmp	@byte_dump
			jmp	@word_dump
			jmp	@long_dump
			jmp	@text_dump

'*******************************************************************************************

byte_dump		and	val2,##$ffff0

			sub	val,val2
			add	val,#1
			
:loop			test	val2,#$f wz
		if_nz	jmp	@:loop2

			calla	@esc_check
		if_e	jmp	@:exit

			pushb	val2
			mov	hex_digits,#5
			mov	hex_style,#0
			calla	@show_hex
			serouta	#":"
			serouta	#" "

:loop2			rdbyte	ax,val2
			add	val2,#1
			pushb	ax
			mov	hex_digits,#2
			calla	@show_hex
			serouta	#" "
			incmod	cmd,#15 wz,wc
		if_c	serouta	#13

			djnz	val,@:loop
:exit			serouta	#13
	
			jmp	@prompt
'*******************************************************************************************

word_dump		and	val2,##$ffff8

			sub	val,val2
			add	val,#1
			shr	val,#1
			
:loop			test	val2,#$f wz
		if_nz	jmp	@:loop2

			calla	@esc_check
		if_e	jmp	@:exit

			pushb	val2
			mov	hex_digits,#5
			mov	hex_style,#0
			calla	@show_hex
			serouta	#":"
			serouta	#" "

:loop2			rdword	ax,val2
			add	val2,#2
			pushb	ax
			mov	hex_digits,#4
			calla	@show_hex
			serouta	#" "
			serouta	#" "
			incmod	cmd,#7 wz,wc
		if_c	serouta	#13

			djnz	val,@:loop

:exit			serouta	#13
	
			jmp	@prompt
'*******************************************************************************************

long_dump		and	val2,##$ffffc

			sub	val,val2
			add	val,#1
			shr	val,#2
			
:loop			test	val2,#$f wz
		if_nz	jmp	@:loop2

			calla	@esc_check
		if_e	jmp	@:exit

			pushb	val2
			mov	hex_digits,#5
			mov	hex_style,#0
			calla	@show_hex
			serouta	#":"
			serouta	#" "

:loop2			rdlong	ax,val2
			add	val2,#4
			pushb	ax
			mov	hex_digits,#8
			mov	hex_style,#1
			calla	@show_hex
			serouta	#" "
			serouta	#" "
			incmod	cmd,#3 wz,wc
		if_c	serouta	#13

			djnz	val,@:loop

:exit			serouta	#13
	
			jmp	@prompt

'*******************************************************************************************

text_dump		and	val2,##$ffff0

			sub	val,val2
			add	val,#1

:loop			test	val2,#$1f wz
		if_nz	jmp	@:loop2

			calla	@esc_check
		if_e	jmp	@:exit

			pushb	val2
			mov	hex_digits,#5
			mov	hex_style,#0
			calla	@show_hex
			serouta	#":"
			serouta	#" "

:loop2			rdbyte	ax,val2
			add	val2,#1

			cmp	ax,#32 wz,wc
		if_b	mov	ax,#"."
			cmp	ax,#127 wz,wc
		if_a	mov	ax,#"."
			serouta	ax
	
			incmod	cmd,#31 wz,wc
		if_c	serouta	#13

			djnz	val,@:loop
:exit			serouta	#13

			jmp	@prompt

'*******************************************************************************************
aux_dump		serouta	#13

			getptry	cmd
			setptry	#0

			mov	ax,val
			or	ax,val2 wz
		if_z	mov	repeats,#256
		if_z	setptry	#0
		if_z	jmp	@:loop

			setptry	val2
			mov	repeats,val
			sub	repeats,val2 wz
			add	repeats,#1
			mins	repeats,#1
			maxs	repeats,#256
		

:loop			serouta	#"A"
			serouta	#"u"
			serouta	#"x"
			serouta	#" "
			serouta	#"$"

			getptry	ax
			pushb	ax
			mov	hex_digits,#2
			calla	@show_hex
			serouta	#":"	
			serouta	#" "

			serouta	#"$"
			rdaux	ax,ptry
			pushb	ax
			mov	hex_style,#1
			mov	hex_digits,#8
			calla	@show_hex
			serouta	#" "

			serouta	#"%"
			rdaux	ax,ptry++
			pushb	ax
			mov	bin_digits,#32
			mov	bin_style,#5
			calla	@show_binary

			serouta	#13
			
			calla	@esc_check
		if_e	jmp	@:exit


			djnz	repeats,@:loop

:exit			setptry	cmd
			jmp	@prompt

'*******************************************************************************************

error			pushb	#msg_error
			calla	@show_msg
			jmp	@prompt

'*******************************************************************************************

show_elapsed		pushb	#msg_elapsed
			calla	@show_msg

			cmp	elapsed,##9999 wz,wc
		if_be	jmp	@show_ns


show_us			calla	@div_10000
			pushb	elapsed
			calla	@show_decimal
			serouta	#"."

			cmp	ex,##1000 wz,wc
		if_b	serouta	#"0"
			cmp	ex,#100 wz,wc
		if_b	serouta	#"0"
			cmp	ex,#10 wz,wc
		if_b	serouta	#"0"   

			pushb	ex
			calla	@show_decimal
			pushb	#msg_us	
			calla	@show_msg
			serouta	#13
			reta

show_ns			calla	@div_10
			pushb	elapsed
			calla	@show_decimal
			serouta	#"."
			pushb	ex
			calla	@show_decimal
			pushb	#msg_ns
			calla	@show_msg
			serouta	#13
			reta	

'*******************************************************************************************
div_10			mov	ex,elapsed
			mov	elapsed,#0
:loop			cmpsub	ex,#10 wz,wc
		if_c	add	elapsed,#1
		if_c	jmp	@:loop
			reta
'*******************************************************************************************
div_10000		mov	ex,#0
			cmp	elapsed,##9999 wz,wc
		if_be	reta

			mov	ex,elapsed
			mov	elapsed,#0
:loop			cmpsub	ex,##10_000 wz,wc
		if_c	add	elapsed,#1
		if_c	jmp	@:loop
			reta

'*******************************************************************************************

show_msg		popb	bx

			cmp	bx,#last_msg wz,wc
		if_ae	mov	bx,_bad_msg_num
		if_ae	jmp	@show_msg_direct

bug		'	loclong	bx,@msg_table

			shl	bx,#2
			add	bx,_msg_table	'loclong replacement

			rdlong	bx,bx

show_msg_direct		rdbyte	ex,bx wz
			add	bx,#1
		if_z	reta	wz,wc
			serouta	ex
			jmp	@show_msg_direct

msg_table		long	@bad_msg
			long	@_title_	'msg title
			long	@_done_		'msg_done
			long	@_byte_		'msg_byte
			long	@_word_		'msg_word
			long	@_long_		'msg_long
			long	@_text_		'msg_text
			long	@_pass_		'msg_pass
			long	@_tested_	'msg_tested
			long	@_returns_	'msg_returns
			long	@_inst_		'msg_inst
			long	@_before_	'msg_before
			long	@_after_	'msg_after
			long	@_log_		'msg_log
			long	@_on_		'msg_on
			long	@_off_		'msg_off
			long	@_dump_		'msg_dump
			long	@_flags_	'msg_flags
			long	@help		'msg_help
			long	@_task_		'msg_task
			long	@_hub_		'msg_hub
			long	@_dash3_	'msg_dash3
			long	@_dash5_	'msg_dash5
			long	@_fetch_	'msg_fetch
			long	@_stall_	'msg_stall
			long	@_dash4_	'msg_dash4
			long	@_skip_		'msg_skip
			long	@_jump_		'msg_jump
			long	@_unknown_	'msg_inknown
			long	@_vidack_	'msg_video
			long	@_ctra_		'msg_ctra
			long	@_ctrb_		'msg_ctrb
			long	@_rxa_		'msg_rxa
			long	@_txa_		'msg+txa
			long	@_rxb_		'msg_rxb
			long	@_txb_		'msg+txb
			long	@_cogram_	'msg_cogram
			long	@_error_	'msg_error
			long	@_ms_		'msg_ms
			long	@_us_		'msg_us
			long	@_header_	'msg_header
			long	@_elapsed_	'msg_elapsed
			long	@_ns_		'msg_ns

'*******************************************************************************************
			
_title_			byte	"P2 Test Toolbox V1.8",13,0
_before_		byte	"Before:  ",0
_after_			byte	"After:   ",0
_inst_			byte	"Instruction: ",0
_flags_			byte	"Flags: ",0
_pass_			byte	"Pass #",0
_log_			byte	"  Log: ",0
_off_			byte	"OFF",0
_on_			byte	"ON",0
_cogram_		byte	"Cog Ram ",0
_returns_		byte	"returns ",0

_task_			byte	"TASK",0
_hub_			byte	"HUB ",0
_fetch_			byte	"FETCH ",0
_go_			byte	"GO ",0
_stall_			byte	"STALL ",0
_cond_			byte	"COND ",0
_skip_			byte	"SKIP ",0
_jump_			byte	"JUMP ",0
_dash2_			byte	"-- ",0
_dash3_			byte	"--- ",0
_dash4_			byte	"---- ",0
_dash5_			byte	"----- ",0
_done_			byte	13,"Done.",13,0
_vidack_		byte	"VIDEO ",0
_ctra_			byte	"CTRA ",0
_ctrb_			byte	"CTRB ",0
_rxa_			byte	"RXA ",0
_txa_			byte	"TXA ",0
_rxb_			byte	"RXB ",0
_txb_			byte	"TXB ",0
_byte_			byte	"BYTE",13,0
_word_			byte	"WORD",13,0
_long_			byte	"LONG",13,0
_text_			byte	"TEXT",13,0
_dump_			byte	"Dump:",0
_unknown_		byte	"??? ",0
_error_			byte	"Error",13,0
_us_			byte	"uS",0
_ms_			byte	"mS",0
_ns_			byte	"nS",0
_elapsed_		byte	"Elapsed = ",0
bad_msg			byte	"** Bad Msg num *** ",0

bin_formats		long	@bin_format0 
			long	@bin_format1 
			long	@bin_format2 
			long	@bin_format3 
			long	@bin_format4 
			long	@bin_format5

hex_formats		long	@hex_format0 
			long	@hex_format1 
			long	@hex_format2 

bin_format0		byte	"dddddddddddddddddddddddddddddddd",0
bin_format1		byte	"dddddddd_dddddddd_dddddddd_dddddddd",0
bin_format2		byte	"dddd_dddd_dddd_dddd_dddd_dddd_dddd_dddd",0
bin_format3		byte	"ddddddd_dd_d_dddd_ddddddddd_ddddddddd",0
bin_format4		byte	"dd_d_d_d_d_d_ddddddddd",0
bin_format5		byte	"dddddddddddddddd_dddddddddddddddd",0

hex_format0		byte	"dddddddd",0
hex_format1		byte	"dddd_dddd",0
hex_format2		byte	"dd_dd_dd_dd",0

help			byte	13
			byte	"P2 Test Toolbox commands",13,13
			byte	"0..9         Decimal digits",13
			byte	"A..F         Hex digits",13
			byte	"$            Hex entry mode",13
			byte	"%            Binary entry mode",13
			byte	"#            Decimal entry mode",13
			byte	"^            Bit number entry mode",13
			byte	"= or ENTER   Load register",13
			byte	"+            Increment/Add to register",13
			byte	"-            Decrement/Sub from  register",13
			byte	"<            Left shift register",13
			byte	">            Right shift register",13
			byte	"[            Left align register",13
			byte	"]            Right align register",13
			byte	"Z            ZERO flag",13
			byte	"Y            CARRY flag",13
			byte	"T            DEST register",13
			byte	"S            SOURCE register",13
			byte	"I            IMMEDIATE",13
			byte	"N            Show Before Header, zeroes pass counter",13
			byte	"X            Execute instruction",13
			byte	"O            Execute once with before/after headers",13
			byte	"*            Execute with test data",13
			byte	"R            Refresh",13
			byte	"L            Logger",13
			byte	"V            View logger results",13
			byte	"K            Vuew trace results",13
			byte	"P            Wipe trace results",13
			byte	"G            Dump COG ram",13
			byte	"H            Dump HUB ram",13
			byte	"J            Change Hub dump mode",13
			byte	"W            Set/Clear effect",13
			byte	"U            USER register",13
			byte	"@            Dump AUX ram",13
			byte	"Q            Options",13
			byte	"                 1 - Hide Instruction",13
			byte	"                 2 - Hide s_reg",13
			byte	"                 3 - Show u_reg",13
			byte	"                 4 - Show elapsed",13
			byte	"                 5 - Hude After: (Execute)",13
			byte	"                 6 - Show header with title",13
			byte	"                 7 - Show header in log results",13
			byte	0



mystack			long	0[16]

mystack2		long	0[16]

d_buffer		long	0[logger_size*5]

con

	#1
	msg_title
	msg_done
	msg_byte
	msg_word
	msg_long
	msg_text
	msg_pass
	msg_tested
	msg_returns
	msg_inst
	msg_before
	msg_after
	msg_log
	msg_on
	msg_off
	msg_dump
	msg_flags
	msg_help
	msg_task
	msg_hub
	msg_dash3
	msg_dash5
	msg_fetch
	msg_stall
	msg_dash4
	msg_skip
	msg_jump
	msg_unknown
	msg_video
	msg_ctra
	msg_ctrb
	msg_rxa
	msg_txa
	msg_rxb
	msg_txb
	msg_cogram
	msg_error
	msg_ms
	msg_us
	msg_header
	msg_elapsed
	msg_ns
	last_msg
